import cv2
import numpy as np



#Fonction permettant d'afficher une image
def afficher_image(image):
    #On affiche l'image dans une fenetre
    cv2.imshow("Image", image)
    #print("Apuyez sur une touche avec la fenetre d'image en premier plan pour continuer.")
    #On attend que l'utilisateur appuie sur une touche
    key = cv2.waitKey(0)
    #On detruit la fenetre
    cv2.destroyAllWindows()
    print "hey"


# La fonction de callback de la souris
# Le premier parametre decrit l'evenement de la souris qui a appele la fonction, les deux suivants donnent les coordonnes ou cet evenement a eu lieu, et le quatrieme decrit l'etat de la souris lors de l'evenement (bouton appuye, relache, etc...)
# Ces parametres sont toujours obligatoires pour cette fonction
# Le cinquieme parametre est personnalisable selon les cas
# Ici, c'est une liste avec en premier, l'image que l'on affiche et dont on va changer des couleurs de pixel
# Ensuite, trois valeurs pour specifier de quelle couleur on souhaite colorier les pixels
# Le dernier parametre est une liste de retour qui stockera les coordonnees des pixels cliques
def click_and_keep(event, x, y, flags, (imagecolor, color, listresult)):
    # if the left mouse button was clicked, record the starting
    # (x, y) coordinates and indicate that cropping is being
    # performed
    if event == cv2.EVENT_MOUSEMOVE and flags == cv2.EVENT_FLAG_LBUTTON:
        imagecolor[y - 1:y + 1, x - 1:x + 1] = color #On met le pixel clique a la couleur souhaitee
        cv2.imshow("image", imagecolor)
        listresult.append((y,x))



#Fonction permettant d'afficher une image et de recuperer les coordonnees des points cliques par l'utilisateur
def afficher_et_cliquer_image(image, color):
    marqueur = []
    im = np.copy(image)
    print ('Cliquez sur l image pour selectionner des points')
    #Creer une fenete pour obtenir les marqueurs de facon interactive
    cv2.namedWindow("image")
    #On lie cette fenetre a la fonction clickandkeep, qui sera appelee a chaque evenement de la souris
    cv2.setMouseCallback("image", click_and_keep, (im, color, marqueur))
    #On sort quand l'utilisateur appuie sur une touche
    cv2.imshow("image", im)
    key = cv2.waitKey(0)
    cv2.destroyAllWindows()

    return marqueur



def list_to_mask(liste_points, imageshape, imagetype):
    res = np.zeros(imageshape, imagetype)

    for (i,j) in liste_points:
        res[i,j]=np.iinfo(imagetype).max

    return res